︠ffd99766-89c7-472b-93df-1cee361e8d78i︠
%html
<p style="text-align: center;"><span style="font-size: xx-large;"><strong>Interpolaci&oacute;n de Lagrange</strong></span></p>
<p style="text-align: left;"><br /><br />Recordemos el siguiente teorema conocido por el alumno.<br /><br /><strong>Teorema.</strong> Sean $(a_1,b_1), \ldots, (a_n,b_n)$, $n$ puntos distintos del plano donde las primeras coordenadas son todas dintintas. $a_i\not = a_j$ si $i\neq j$. Entonces existe un &uacute;nico polinomio $f$ de grado a lo sumo $n-1$ tal que $f(a_i)=b_i$, $i=1,\ldots, n$.<br /><br />Vamos a ver que este teorema no es m&aacute;s que el Teorema Chino de los Restos: la aplicaci&oacute;n $$\begin{matrix}\mathbb{K}[x]&amp;\longrightarrow &amp; \mathbb{K}\\ f&amp;\mapsto &amp; f(a_i)\end{matrix}$$ es un homomorfismo suprayectivo de anillos cuyo n&uacute;cleo es el ideal $(x-a_i)$ y, por tanto, $$\begin{matrix}\frac{\mathbb{K}[x]}{(x-a_i)} &amp;\simeq &amp;\mathbb{K}.\\ f+(x-a_i)&amp;\sim&amp;f(a_i)\end{matrix}$$<br /><br />Dados $n$ puntos $(a_1,b_1),\ldots, (a_n,b_n)$, el problema de buscar un polinomio $f$ tal que $f(a_i)=b_i$, $i=1,\ldots, n$ equivale a saber si el punto $(b_1,\ldots, b_n)$ est&aacute; en la imagen de la aplicaci&oacute;n: $$\begin{matrix}\displaystyle\mathbb{K}[x] &amp;\rightarrow &amp;\displaystyle\frac{\mathbb{K}[x]}{(x-a_1)}\times\cdots \times \frac{\mathbb{K}[x]}{(x-a_1)}&amp;\\ f &amp; \mapsto &amp; \big(f+(x-a_1),\ldots,f+(x-a_n)\big)&amp;=(f(a_1),\ldots, f(a_n))\end{matrix}.$$<br /><br />La primera parte del teorema chino de los restos, afirma que, si los ideales $(x-a_i)$ son comaximales dos a dos entonces siempre hay soluci&oacute;n. Notese que $(x-a_i)$ y $(x-a_j)$ son comaximales si y solo si $a_i\neq a_j$, pues, en ese caso, $$1=\frac{x-a_i -(x-a_j)}{a_j-a_i}\in (x-a_i,x-a_j).$$<br /><br />Por otro lado, la segunda parte del teorema chino de los restos afirma que el n&uacute;cleo del homomorfismo anterior es el ideal&nbsp; $\mathbf{a}=((x-a_1)\cdots (x-a_n))$. As&iacute;, tenemos el isomorfismo: $$\begin{matrix}\displaystyle\frac{\mathbb{K}[x]}{((x-a_1)\cdots(x-a_n))} &amp;\rightarrow &amp;\displaystyle\frac{\mathbb{K}[x]}{(x-a_1)}\times\cdots \times \frac{\mathbb{K}[x]}{(x-a_1)}\\ f +\mathbf{a}&amp; \mapsto &amp; \big(f+(x-a_1),\ldots,f+(x-a_n)\big)\end{matrix}$$ por lo que hay una &uacute;nica clase $F$ m&oacute;dulo $\mathbf{a}$ del problema. Esta clase tiene un &uacute;nico representante dado por un polinomio de grado a lo m&aacute;s $n-1$, que se obtiene de dividir cualquier representante de $F$ por $(x-a_1)\cdots (x-a_n)$.<br /><br />Adem&aacute;s, en este caso, la soluci&oacute;n dada tipicamente en el teorema de interpolaci&oacute;n de Lagrange es la misma que define el teorema Chino de los restos. Sea: $$f_i(x) = \frac{(x-a_1)\cdots(x-a_{i-1})(x-a_{i+1})\cdots (x-a_n)}{(a_i-a_1)\cdots(a_i-a_{i-1})(a_i-a_{i+1})\cdots (a_i-a_n)}$$ estos polinomios cumplen que: $$f_i(a_k) = \left\{\begin{matrix}0 &amp;\textrm{si}&amp; i\neq k\\1&amp;\textrm{si}&amp; i=k\end{matrix} \right.$$<br /><br />por lo que, la soluci&oacute;n buscada es: $$f = b_1f_1(x)+\ldots +b_nf_n(x)$$</p>

︡810d5aae-5804-4521-93b7-248d5a3d258b︡{"html": "<p style=\"text-align: center;\"><span style=\"font-size: xx-large;\"><strong>Interpolaci&oacute;n de Lagrange</strong></span></p>\n<p style=\"text-align: left;\"><br /><br />Recordemos el siguiente teorema conocido por el alumno.<br /><br /><strong>Teorema.</strong> Sean $(a_1,b_1), \\ldots, (a_n,b_n)$, $n$ puntos distintos del plano donde las primeras coordenadas son todas dintintas. $a_i\\not = a_j$ si $i\\neq j$. Entonces existe un &uacute;nico polinomio $f$ de grado a lo sumo $n-1$ tal que $f(a_i)=b_i$, $i=1,\\ldots, n$.<br /><br />Vamos a ver que este teorema no es m&aacute;s que el Teorema Chino de los Restos: la aplicaci&oacute;n $$\\begin{matrix}\\mathbb{K}[x]&amp;\\longrightarrow &amp; \\mathbb{K}\\\\ f&amp;\\mapsto &amp; f(a_i)\\end{matrix}$$ es un homomorfismo suprayectivo de anillos cuyo n&uacute;cleo es el ideal $(x-a_i)$ y, por tanto, $$\\begin{matrix}\\frac{\\mathbb{K}[x]}{(x-a_i)} &amp;\\simeq &amp;\\mathbb{K}.\\\\ f+(x-a_i)&amp;\\sim&amp;f(a_i)\\end{matrix}$$<br /><br />Dados $n$ puntos $(a_1,b_1),\\ldots, (a_n,b_n)$, el problema de buscar un polinomio $f$ tal que $f(a_i)=b_i$, $i=1,\\ldots, n$ equivale a saber si el punto $(b_1,\\ldots, b_n)$ est&aacute; en la imagen de la aplicaci&oacute;n: $$\\begin{matrix}\\displaystyle\\mathbb{K}[x] &amp;\\rightarrow &amp;\\displaystyle\\frac{\\mathbb{K}[x]}{(x-a_1)}\\times\\cdots \\times \\frac{\\mathbb{K}[x]}{(x-a_1)}&amp;\\\\ f &amp; \\mapsto &amp; \\big(f+(x-a_1),\\ldots,f+(x-a_n)\\big)&amp;=(f(a_1),\\ldots, f(a_n))\\end{matrix}.$$<br /><br />La primera parte del teorema chino de los restos, afirma que, si los ideales $(x-a_i)$ son comaximales dos a dos entonces siempre hay soluci&oacute;n. Notese que $(x-a_i)$ y $(x-a_j)$ son comaximales si y solo si $a_i\\neq a_j$, pues, en ese caso, $$1=\\frac{x-a_i -(x-a_j)}{a_j-a_i}\\in (x-a_i,x-a_j).$$<br /><br />Por otro lado, la segunda parte del teorema chino de los restos afirma que el n&uacute;cleo del homomorfismo anterior es el ideal&nbsp; $\\mathbf{a}=((x-a_1)\\cdots (x-a_n))$. As&iacute;, tenemos el isomorfismo: $$\\begin{matrix}\\displaystyle\\frac{\\mathbb{K}[x]}{((x-a_1)\\cdots(x-a_n))} &amp;\\rightarrow &amp;\\displaystyle\\frac{\\mathbb{K}[x]}{(x-a_1)}\\times\\cdots \\times \\frac{\\mathbb{K}[x]}{(x-a_1)}\\\\ f +\\mathbf{a}&amp; \\mapsto &amp; \\big(f+(x-a_1),\\ldots,f+(x-a_n)\\big)\\end{matrix}$$ por lo que hay una &uacute;nica clase $F$ m&oacute;dulo $\\mathbf{a}$ del problema. Esta clase tiene un &uacute;nico representante dado por un polinomio de grado a lo m&aacute;s $n-1$, que se obtiene de dividir cualquier representante de $F$ por $(x-a_1)\\cdots (x-a_n)$.<br /><br />Adem&aacute;s, en este caso, la soluci&oacute;n dada tipicamente en el teorema de interpolaci&oacute;n de Lagrange es la misma que define el teorema Chino de los restos. Sea: $$f_i(x) = \\frac{(x-a_1)\\cdots(x-a_{i-1})(x-a_{i+1})\\cdots (x-a_n)}{(a_i-a_1)\\cdots(a_i-a_{i-1})(a_i-a_{i+1})\\cdots (a_i-a_n)}$$ estos polinomios cumplen que: $$f_i(a_k) = \\left\\{\\begin{matrix}0 &amp;\\textrm{si}&amp; i\\neq k\\\\1&amp;\\textrm{si}&amp; i=k\\end{matrix} \\right.$$<br /><br />por lo que, la soluci&oacute;n buscada es: $$f = b_1f_1(x)+\\ldots +b_nf_n(x)$$</p>"}︡
︠d5201fd6-cba8-4db3-abf9-b65f5f6cbd10︠
K = QQ['x']
Kfield = K.fraction_field()
x = K.gen()
︡58fa0f1a-f588-45b6-91e3-9c5644662fa0︡︡
︠31ae9b2d-ab03-4216-a246-375cf2528695︠
def lagrange_interpolation(puntos, valores):
    n = len(puntos)
    polinomio_nucleo = prod([x-puntos[i] for i in range(n)])
    interpolador = 0
    for i in range(n):
        pol_base = polinomio_nucleo // (x-puntos[i])
        pol_base = pol_base * valores[i] / pol_base(x = puntos[i])
        interpolador = interpolador + pol_base
    return interpolador
︡04b8d49d-67b1-42f9-8384-5dcdf68cb14b︡︡
︠4a4186f7-d3a5-45c5-9b4b-a300714f9be9i︠
%hide
@interact
def interpolacion(puntos2d = input_box(default=[[0, -3], [1, 1], [2, 7], [4, 10],[5,6],[6,2],[10,2],[12,2],[13,3]])):
    puntos = [foo[0] for foo in puntos2d]
    valores = [foo[1] for foo in puntos2d]
    f = lagrange_interpolation(puntos, valores)
    minimo =min(puntos)
    maximo =max(puntos)
    figure = plot(f,minimo-1,maximo+1)
    figure = figure + sum([point(i,color='red',size=30) for i in puntos2d])
    figure.show()
︡c0df5870-c3aa-4959-a6ba-83615afdc01e︡︡
︠cb46b4ef-e768-4f3f-92df-3fa8d60a6d55i︠
%html
<p style="text-align: center;"><span style="font-size: xx-large;"><strong>C&aacute;lculo de determinantes usando el Teorema Chino de los restos</strong></span></p>
<p style="text-align: left;"><span style="font-size: xx-large;"><span style="font-size: medium;">Supongamos que tenemos una matriz $$M = \begin{pmatrix}a_{11}&amp;\ldots&amp;a_{1n}\\\vdots&amp;\ddots&amp;\vdots\\a_{n1}&amp;\ldots &amp;a_{nn}\end{pmatrix}$$ cuyas entradas son polinomios $a_{ij}\in\mathbb{Q}[x]$.</span></span></p>
<p style="text-align: left;"><span style="font-size: xx-large;"><span style="font-size: medium;">Si calculamos el determinante de $M$ usando el m&eacute;todo de Gauss tenemos el problema de que el grado de las funciones racionales que aparecen en la eliminaci&oacute;n gausiana crece exponenciamente con el tama&ntilde;o $n$ de la matriz.<br /></span></span></p>

︡4c9fc319-56c9-4e8d-a08f-7cb3ec90de3f︡{"html": "<p style=\"text-align: center;\"><span style=\"font-size: xx-large;\"><strong>C&aacute;lculo de determinantes usando el Teorema Chino de los restos</strong></span></p>\n<p style=\"text-align: left;\"><span style=\"font-size: xx-large;\"><span style=\"font-size: medium;\">Supongamos que tenemos una matriz $$M = \\begin{pmatrix}a_{11}&amp;\\ldots&amp;a_{1n}\\\\\\vdots&amp;\\ddots&amp;\\vdots\\\\a_{n1}&amp;\\ldots &amp;a_{nn}\\end{pmatrix}$$ cuyas entradas son polinomios $a_{ij}\\in\\mathbb{Q}[x]$.</span></span></p>\n<p style=\"text-align: left;\"><span style=\"font-size: xx-large;\"><span style=\"font-size: medium;\">Si calculamos el determinante de $M$ usando el m&eacute;todo de Gauss tenemos el problema de que el grado de las funciones racionales que aparecen en la eliminaci&oacute;n gausiana crece exponenciamente con el tama&ntilde;o $n$ de la matriz.<br /></span></span></p>"}︡
︠c19d71c0-a386-4896-99bb-512aa4954555︠
%cython

from sage.all import copy

def haz_ceros(M,k):
    # Hacer ceros en la matriz M debajo del elemento k,k
    # Devuelve la matriz y un elemento 0 o 1 si se ha hecho un intercambio de filas
    n = M.nrows()
    # buscamos un pivote
    pivote = k
    while pivote< n and M[pivote,k] ==0:
        pivote += 1
    if pivote == n:
        #No hay nada que reducir
        return M, 0
    #Modificamos la matriz
    if pivote != k:
        M.swap_rows(pivote, k)
        swap = 1
    else:
        swap = 0
    for i in range(k+1,n):
        f = ~M[k,k]
        M.add_multiple_of_row(i, k, -M[i,k]*f,start_col=k )
    return M, swap
︡d6b24eaa-0143-4f64-878d-e4ad2e74e08d︡︡
︠af968e29-d48a-433a-9e1d-1228eaa3a566︠
def escalona(M):
    n = M.nrows()
    swap = 0
    for k in range(n-1):
        M, s = haz_ceros(M,k)
        swap = swap + s
    return M, swap
︡29996540-aee4-4e9c-ae0a-045f8b0eba18︡︡
︠5ba9f119-fefb-43d0-9b31-0ab1f0032944i︠
%html
<p>El c&oacute;digo anterior escalona una matriz dada por filas y tambi&eacute;n devuelve el n&uacute;mero de intercambios que hemos hecho en las filas de la matriz. Apliqu&eacute;moslo a unos ejemplos</p>

︡b574ebe8-31e8-4b36-9180-9fdec538847e︡{"html": "<p>El c&oacute;digo anterior escalona una matriz dada por filas y tambi&eacute;n devuelve el n&uacute;mero de intercambios que hemos hecho en las filas de la matriz. Apliqu&eacute;moslo a unos ejemplos</p>"}︡
︠9b5d4899-c651-4ea7-a1f9-aab000ba4ca9︠
M = matrix(Kfield, 3, 3, lambda i,j: ZZ[x].random_element(1))
M
︡1f6918b3-af38-40c3-8fd3-c0f804162e36︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\begin{array}{rrr}\n-10 & 10 x + 3 & x - 1 \\\\\n-4 x & -x + 1 & 5 x \\\\\nx + 1 & -x + 1 & x - 74\n\\end{array}\\right)</span>"}︡
︠4c78ffa7-bcae-4e32-9a61-2e8ecc6b735b︠
escalona(M)
︡96c1dc88-daf7-498c-9d79-958a672e69df︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\left(\\begin{array}{rrr}\n-10 & 10 x + 3 & x - 1 \\\\\n0 & -4 x^{2} - \\frac{11}{5} x + 1 & -\\frac{2}{5} x^{2} + \\frac{27}{5} x \\\\\n0 & 0 & \\frac{-\\frac{19}{2} x^{3} + \\frac{1466}{5} x^{2} + 157 x - \\frac{741}{10}}{-4 x^{2} - \\frac{11}{5} x + 1}\n\\end{array}\\right), 0\\right)</span>"}︡
︠c289e8f9-85ef-4bb2-aebb-1bc0a87bc6f3︠
M = matrix(Kfield, 7, 7, lambda i,j: ZZ[x].random_element(2))
M
︡5b115ef4-67d2-4afd-bab9-a983077dfe03︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\begin{array}{rrrrrrr}\n-4 x^{2} + x - 1 & -2 x + 1 & -x^{2} + 3 & 3 x^{2} + 25 x - 22 & x^{2} + 2 x + 1 & -x^{2} - x & 3 x^{2} \\\\\nx^{2} + 8 x & 0 & -5 x^{2} - x + 1 & -2 x^{2} - x + 3 & x^{2} - x + 1 & -3 x + 1 & 12 x^{2} - 13 x \\\\\n-46 x^{2} - x & x^{2} + 2 x - 1 & 2 x^{2} + x - 27 & 13 x^{2} + x + 1 & x^{2} - x - 31 & -x^{2} + x + 1 & x + 2 \\\\\nx^{2} + x & 3 x^{2} + 14 x - 1 & 4 x^{2} - 20 & x^{2} - 2 x & -2 x^{2} - x & x^{2} - 2 x + 1 & -x^{2} - 11 x + 2 \\\\\n3 x - 4 & 2 x^{2} + x + 2 & -23 x + 26 & 0 & x - 1 & -12 x^{2} + x - 1 & x^{2} - 4 x \\\\\n-x^{2} - 1 & -x^{2} & -x^{2} - x - 8 & 2 x^{2} - 4 & -x + 6 & -x & x^{2} + 4 \\\\\nx^{2} - 8 x & -x^{2} + 16 & x^{2} - 2 x & -41 x^{2} + x + 4 & 2 x^{2} + 1 & -x^{2} + 10 x + 12 & -4 x^{2} + 16 x - 7\n\\end{array}\\right)</span>"}︡
︠a2acfb57-176c-4f54-8282-4e16455f479a︠
N=escalona(M)[0]
matrix(ZZ,7,7,lambda i,j: max(N[i][j].numerator().degree(),N[i][j].denominator().degree()))
︡29661a4f-ed26-4f2b-948c-154eb2151b54︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\begin{array}{rrrrrrr}\n2 & 1 & 2 & 2 & 2 & 2 & 2 \\\\\n0 & 3 & 4 & 4 & 4 & 4 & 4 \\\\\n0 & 0 & 6 & 6 & 6 & 6 & 5 \\\\\n0 & 0 & 0 & 8 & 8 & 8 & 8 \\\\\n0 & 0 & 0 & 0 & 10 & 10 & 10 \\\\\n0 & 0 & 0 & 0 & 0 & 12 & 12 \\\\\n0 & 0 & 0 & 0 & 0 & 0 & 14\n\\end{array}\\right)</span>"}︡
︠9141a750-0998-4805-ad42-76227a985717i︠
%html
<p>Es crecimiento anterior en el grado de los polinomios es lineal. Este crecimiento es mucho m&aacute;s acusado si incluimos <span style="color: #ff0000;">denominadores</span></p>

︡44d538c8-0a8b-4fb9-809e-49e8e1242d9e︡{"html": "<p>Es crecimiento anterior en el grado de los polinomios es lineal. Este crecimiento es mucho m&aacute;s acusado si incluimos <span style=\"color: #ff0000;\">denominadores</span></p>"}︡
︠9cdc4a10-ccec-4123-bf1a-5f1158ab15e4︠
M = matrix(Kfield, 7, 7, lambda i,j: Kfield.random_element(3))
M
︡8a5badb7-89a8-411f-b17f-9daf1bbcbe38︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\begin{array}{rrrrrrr}\n\\frac{x^{3} - 1}{-\\frac{1}{16} x^{3} + \\frac{5}{2} x^{2} + \\frac{7}{11} x - 1} & \\frac{-\\frac{1}{6} x^{3} + x^{2}}{-\\frac{1}{2} x - \\frac{5}{2}} & \\frac{\\frac{1}{3} x^{2} - \\frac{1}{2} x - \\frac{1}{48}}{-21 x^{3} - x^{2} - 2} & \\frac{x^{3} - x^{2} - \\frac{1}{3} x}{-x^{3} - \\frac{4}{3} x^{2} + x + \\frac{1}{19}} & \\frac{\\frac{1}{5} x^{3} + \\frac{1}{2} x^{2} - x - 1}{-\\frac{1}{9} x^{3} + x^{2} - \\frac{1}{4} x + \\frac{1}{2}} & \\frac{-\\frac{1}{3} x^{3} - \\frac{1}{2} x^{2} - 5 x + 3}{6 x^{3} + \\frac{3}{2} x^{2} + 6 x} & \\frac{-x^{3} + \\frac{1}{2} x - 1}{x^{3} + \\frac{3}{4} x^{2} - \\frac{1}{2} x + 1} \\\\\n\\frac{x^{3} + \\frac{1}{2} x^{2} - \\frac{1}{3} x - 2}{-x^{3} - 33 x^{2} - 2} & \\frac{-2 x^{3} + 6 x^{2} + \\frac{1}{283}}{-2 x^{3} + x^{2} - x + \\frac{1}{2}} & \\frac{-3 x^{3} - \\frac{1}{3} x^{2} + 2 x + \\frac{1}{3}}{-x^{3} + \\frac{28}{5} x^{2} + \\frac{49}{3} x} & \\frac{-4 x^{3} - 9 x^{2} - \\frac{3}{5} x - 1}{-\\frac{1}{4} x^{3} + x^{2} - x + 1} & \\frac{\\frac{3}{2} x^{2} - \\frac{4}{5} x - 2}{-x^{3} + 3 x^{2} + x + 3} & \\frac{-2 x^{3} - 2 x^{2} - 2}{\\frac{2}{5} x^{3} - x - 1} & \\frac{-x^{3} + \\frac{1}{76} x^{2} - \\frac{2}{3} x - \\frac{1}{2}}{\\frac{1}{70} x^{3} - \\frac{5}{16} x - \\frac{1}{3}} \\\\\n\\frac{-\\frac{1}{2} x^{2} + 1}{x^{3}} & \\frac{\\frac{1}{3} x^{3} + \\frac{1}{24} x^{2} - x + 5}{-x^{3} - \\frac{3}{101} x^{2} - \\frac{1}{3} x - 1} & \\frac{\\frac{1}{8} x^{3} - \\frac{1}{7} x^{2} + 5}{-x^{3} + \\frac{1}{3} x^{2} - x + 3} & \\frac{2 x^{3} - 4 x^{2} + x + \\frac{1}{6}}{x^{3} + 2 x^{2} - x} & \\frac{\\frac{81}{5} x^{2} + x}{-\\frac{1}{5} x^{3} + x - \\frac{1}{2}} & \\frac{2 x^{3} - x^{2}}{-\\frac{1}{3} x^{3} - \\frac{1}{14} x^{2} - x - 1} & \\frac{-\\frac{4}{13} x^{3} - x^{2} - x - 1}{x^{2} + \\frac{1}{2} x + \\frac{1}{7}} \\\\\n\\frac{-x^{2} + \\frac{1}{5} x - 1}{x^{3} - \\frac{1}{4} x^{2} + \\frac{1}{2} x - \\frac{1}{36}} & \\frac{-2 x^{3} + \\frac{1}{2} x^{2} - x + 1}{\\frac{1}{4} x^{3} + 6 x^{2} + \\frac{1}{2} x} & \\frac{-\\frac{1}{9} x^{2} + \\frac{1}{6} x}{\\frac{1}{2} x^{3} + 2 x - 3} & \\frac{3 x^{3} + 4 x}{-\\frac{1}{2} x^{3} + \\frac{1}{2} x^{2} + \\frac{1}{2}} & \\frac{-\\frac{1}{2} x^{2} + \\frac{1}{2} x + 1}{\\frac{2}{3} x} & \\frac{2 x^{2} - x + \\frac{1}{2}}{3 x^{3} + \\frac{1}{7} x^{2} + 2 x + \\frac{1}{5}} & \\frac{x^{3} + x^{2} + \\frac{2}{3} x}{-\\frac{1}{2} x^{3} + 3 x^{2} - \\frac{2}{3} x - 1} \\\\\n\\frac{-\\frac{2}{5} x^{3} - 5 x^{2} - x + \\frac{1}{4}}{-3 x^{3} + \\frac{3}{2} x^{2} + 2 x + 2} & \\frac{-x - 5}{-2 x - 1} & \\frac{x^{3} - 2 x^{2} - x + 1}{\\frac{1}{2} x^{2}} & \\frac{3 x - 1}{-\\frac{1}{2} x^{2} + 5 x + \\frac{1}{2}} & \\frac{-x^{3} - \\frac{1}{12} x - 2}{11 x^{3} + x^{2} - \\frac{7}{9} x - 50} & \\frac{x^{2} - 1}{x^{3} - \\frac{3}{2} x^{2} + 3 x - 1} & \\frac{x^{3} + \\frac{1}{2} x^{2} + 2 x + 4}{-\\frac{1}{2} x^{3} - \\frac{1}{4} x^{2} - \\frac{2}{419} x - 1} \\\\\n\\frac{-\\frac{7}{2} x^{2} - x + \\frac{1}{5}}{-\\frac{2}{3} x^{3} - x^{2} - x - \\frac{193}{6}} & \\frac{x^{3} - \\frac{1}{4} x^{2} + \\frac{1}{2}}{x + 2} & \\frac{-x^{3} - \\frac{1}{3} x - 1}{4 x^{3} - x^{2} + \\frac{1}{3} x + \\frac{1}{2}} & \\frac{-x^{3} + \\frac{3}{2} x^{2} - 3 x + \\frac{2}{3}}{x^{3} - \\frac{1}{7} x} & \\frac{\\frac{3}{8} x^{3} - \\frac{3}{11} x - \\frac{1}{2}}{-3 x^{3} + x^{2} + 2 x + \\frac{3}{14}} & \\frac{-x^{3} - 5 x + \\frac{1}{2}}{-7 x^{2} + x - 1} & \\frac{11 x + 2}{-\\frac{3}{2} x^{3} - \\frac{2}{3} x^{2} - x + \\frac{13}{5}} \\\\\n\\frac{-\\frac{3}{2} x^{3} + x^{2} + 3 x + \\frac{9}{7}}{2 x^{2} + 9 x + 2} & \\frac{-\\frac{1}{3} x^{3} + \\frac{1}{4} x + \\frac{1}{4}}{\\frac{1}{2} x^{3} - x - 1} & \\frac{\\frac{1}{3} x^{3} + \\frac{1}{12} x^{2} - \\frac{1}{7}}{-\\frac{1}{2} x^{3}} & \\frac{\\frac{27}{4} x^{3} - 3 x^{2} + 1096 x + \\frac{1}{11}}{-\\frac{1}{9} x^{2} - \\frac{1}{3} x + 3} & \\frac{\\frac{6}{77} x^{3} + \\frac{1}{6} x^{2} - 2 x - 3}{\\frac{5}{19} x^{3}} & \\frac{-x^{3} + \\frac{7}{32} x^{2} + 1}{x^{3} + \\frac{1}{2} x^{2} + x} & \\frac{-3 x^{3} - x^{2} + 2 x + \\frac{1}{3}}{\\frac{1}{2} x^{3} + \\frac{1}{4} x^{2} + \\frac{6}{7} x + 3}\n\\end{array}\\right)</span>"}︡
︠ed0e7a82-552c-411f-9513-ae45100df717i︠
%html
<p>Escalonamos la matriz anterior usando eliminaci&oacute;n Gaussiana y escribimos una nueva matriz que contenga en sus entradas el m&aacute;ximo de los grados de numerador y denominador</p>

︡5a324ee0-b656-41b3-be2d-2cfb795df586︡{"html": "<p>Escalonamos la matriz anterior usando eliminaci&oacute;n Gaussiana y escribimos una nueva matriz que contenga en sus entradas el m&aacute;ximo de los grados de numerador y denominador</p>"}︡
︠23a6e809-39f6-4609-9b05-5d38af9a9472︠
N=escalona(M)[0]
matrix(ZZ,7,7,lambda i,j: max(N[i][j].numerator().degree(),N[i][j].denominator().degree()))
︡5fa5e5e6-a68f-4e34-97e1-89983a356060︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\begin{array}{rrrrrrr}\n3 & 3 & 3 & 3 & 3 & 3 & 3 \\\\\n0 & 12 & 12 & 12 & 12 & 12 & 12 \\\\\n0 & 0 & 26 & 25 & 27 & 27 & 27 \\\\\n0 & 0 & 0 & 46 & 46 & 48 & 47 \\\\\n0 & 0 & 0 & 0 & 68 & 70 & 70 \\\\\n0 & 0 & 0 & 0 & 0 & 99 & 99 \\\\\n0 & 0 & 0 & 0 & 0 & 0 & 133\n\\end{array}\\right)</span>"}︡
︠fafc96c1-324b-4e7a-8afd-86b9b6cd9833i︠
%html
<p>En cualquier caso, el m&eacute;todo de Gauss permite calcular el determinante de la matriz</p>

︡89030e31-bbce-47ef-a594-a0d7f01eb7ed︡{"html": "<p>En cualquier caso, el m&eacute;todo de Gauss permite calcular el determinante de la matriz</p>"}︡
︠d0d6053e-4f70-4225-98bf-57bd96fbe5be︠
def determinante_a_la_Gauss(M):
    M = M.change_ring(K.fraction_field())
    n = M.nrows()
    swap = 0
    for k in range(n-1):
        M, s = haz_ceros(M,k)
        swap = swap + s
    return prod( M.diagonal())*(-1)**swap
︡8d432447-7cdb-4f46-983d-9734d3924a93︡︡
︠6e036392-1b5e-4c58-a3d6-8344b4be79ec︠
M = random_matrix(K, 5)
M.change_ring(Kfield)
M
︡6c766f68-a4b2-4da0-b9f3-91955c596e9a︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\begin{array}{rrrrr}\n-\\frac{1}{3} x^{2} + 1 & -x^{2} - \\frac{3}{2} x - 2 & -4 x^{2} + \\frac{5}{2} x - \\frac{1}{2} & -x^{2} - \\frac{1}{2} x + 2 & \\frac{1}{8} x^{2} + 2 x - 1 \\\\\nx^{2} - \\frac{7}{160} x + \\frac{1}{10} & \\frac{1}{3} x^{2} - 6 x - \\frac{1}{5} & -4 x^{2} - \\frac{2}{3} x & -2 x^{2} + \\frac{1}{2} x & 5 x^{2} - x \\\\\n\\frac{1}{3} x^{2} - 6 x & 8 x^{2} + 17 x & -\\frac{1}{10} x^{2} + \\frac{1}{2} x - \\frac{1}{3} & \\frac{2}{13} x^{2} - \\frac{1}{2} x - \\frac{1}{25} & -\\frac{1}{2} x \\\\\n-\\frac{1}{8} x^{2} - 1 & \\frac{1}{8} x^{2} + \\frac{26}{3} x - 1 & -\\frac{1}{2} x^{2} - x - 1 & 9 x & \\frac{1}{7} x^{2} \\\\\n-x & -x - 1 & -45 x - 1 & -x^{2} - 2 x - \\frac{1}{3} & -3 x^{2} - 2\n\\end{array}\\right)</span>"}︡
︠59e87922-487e-40e7-8392-8db536aa4afc︠
determinante_a_la_Gauss(M)
︡8b81fdca-e0e0-4a4b-a309-ca639117f9a7︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}-\\frac{1908293}{131040} x^{10} + \\frac{16511935163}{11980800} x^{9} + \\frac{2392628250307}{251596800} x^{8} + \\frac{7027749079727}{628992000} x^{7} + \\frac{15439832494061}{628992000} x^{6} - \\frac{9746337780659}{235872000} x^{5} + \\frac{346857133271}{37739520} x^{4} + \\frac{10418523289}{9828000} x^{3} + \\frac{965758711}{7862400} x^{2} - \\frac{379361}{54000} x - \\frac{164}{375}</span>"}︡
︠662d2b74-836b-4ace-8a65-cc6ca12d07b8︠
determinante_a_la_Gauss(M) - M.det()
︡ce9013c9-8357-4f44-89e8-84fefd5458db︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}0</span>"}︡
︠a43f4d1a-96d7-4ee5-8439-1581123cf767i︠
%html
<p>En la matriz anterior, en cada columna hay elementos de grado, a lo m&aacute;s, $2$, luego el determinante solo puede tener grado a lo m&aacute;s $2\cdot 5=10$.</p>
<p>Si evaluo la matriz en $11$ elementos $r_1,\ldots,r_{11}$ de $\mathbb{K}$ distintos, hay un &uacute;nico polinomio $f$ de grado a lo m&aacute;s 10 tal que $f(r_i) = det(M(i))$. Como el determinante es un polinomio que cumple lo anterior, tenemos que el determinante lo podemos calcular con la interpolaci&oacute;n de Lagrange/Teorema Chino de los Restos.</p>

︡3a7fea54-9a1b-4cd6-94b4-792247116a25︡{"html": "<p>En la matriz anterior, en cada columna hay elementos de grado, a lo m&aacute;s, $2$, luego el determinante solo puede tener grado a lo m&aacute;s $2\\cdot 5=10$.</p>\n<p>Si evaluo la matriz en $11$ elementos $r_1,\\ldots,r_{11}$ de $\\mathbb{K}$ distintos, hay un &uacute;nico polinomio $f$ de grado a lo m&aacute;s 10 tal que $f(r_i) = det(M(i))$. Como el determinante es un polinomio que cumple lo anterior, tenemos que el determinante lo podemos calcular con la interpolaci&oacute;n de Lagrange/Teorema Chino de los Restos.</p>"}︡
︠5f189835-59a2-4ca2-b3fc-5f49f3e4c26e︠
def determinante_chino(M):
    n = M.nrows()
    d = [M.row(i).denominator() for i in range(n)]
    M = diagonal_matrix(d)*M
    M = M.change_ring(K)
    cota = sum([max([termino.degree() for termino in M.row(i)]) for i in range(n)])
    puntos = range(cota+1)
    valores = []
    for i in puntos:
        Mi = M(i)
        Mi = Mi.change_ring(QQ)
        DET = determinante_a_la_Gauss(Mi)
        valores.append(DET)
    DET = lagrange_interpolation(puntos, valores)/prod(d)
    return DET
︡729d2715-027a-4bd6-afea-979aeb318fe1︡︡
︠cdf18749-1103-44d2-95a9-705acb3b72a4︠
M = random_matrix(K,3)
M
︡3b7ac658-c157-4932-b3b6-60554571b4fd︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\begin{array}{rrr}\n-\\frac{1}{2} x + 1 & -\\frac{5}{4} x^{2} - \\frac{2}{19} x + \\frac{1}{2} & -\\frac{1}{2} x^{2} + \\frac{1}{2} x - \\frac{1}{34} \\\\\nx^{2} + 2 x - \\frac{1}{12} & -\\frac{1}{2} x^{2} - \\frac{2}{15} x & 18 x^{2} + \\frac{1}{36} x - 1 \\\\\n-\\frac{2}{3} x^{2} + \\frac{1}{5} x + 5 & \\frac{2}{3} x^{2} - x + 1 & x + 4\n\\end{array}\\right)</span>"}︡
︠4085d367-f029-463b-afe3-08481904cd2c︠
determinante_chino(M) - M.det()
︡a694181e-3d26-4787-ad81-e368ae229c71︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}0</span>"}︡
︠20289df5-9c6f-4813-b429-50f1dd706943︠
determinante_a_la_Gauss(M) - M.det()
︡dd6eb4ef-ff9f-4654-92f3-6cf4e48bd035︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}0</span>"}︡
︠d62df8fb-bf6a-4972-920c-71eb8117dbdei︠
%html
<p>Comparemos los dos algoritmos para calcular determinantes en matrices aleatorias de distintos tama&ntilde;os</p>
<p><strong>Caso de entradas polinomios</strong></p>

︡c9c86910-5bf4-48b6-a9e0-0413fcaedd31︡{"html": "<p>Comparemos los dos algoritmos para calcular determinantes en matrices aleatorias de distintos tama&ntilde;os</p>\n<p><strong>Caso de entradas polinomios</strong></p>"}︡
︠c1a713c4-a2a4-4dce-9467-a655f39600ac︠
for i in range(2,13):
    M = random_matrix(K, i)
    M = M.change_ring(Kfield)
    print('matriz de tamaño: '+str(i))
    timeit('determinante_chino(M)',repeat=1,number=1)
    timeit('determinante_a_la_Gauss(M)',repeat=1,number=1)
︡f8a5dd93-8b26-4f39-9e89-e9a7409daca4︡{"stdout": "matriz de tama\u00f1o: 2\n1 loops, best of 1: 9.3 ms per loop\n1 loops, best of 1: 437 \u00b5s per loop\nmatriz de tama\u00f1o: 3\n1 loops, best of 1: 14.1 ms per loop\n1 loops, best of 1: 1.07 ms per loop\nmatriz de tama\u00f1o: 4\n1 loops, best of 1: 23.9 ms per loop\n1 loops, best of 1: 2.24 ms per loop\nmatriz de tama\u00f1o: 5\n1 loops, best of 1: 46.1 ms per loop\n1 loops, best of 1: 4.3 ms per loop\nmatriz de tama\u00f1o: 6\n1 loops, best of 1: 71.7 ms per loop\n1 loops, best of 1: 8.56 ms per loop\nmatriz de tama\u00f1o: 7\n1 loops, best of 1: 123 ms per loop\n1 loops, best of 1: 15.3 ms per loop\nmatriz de tama\u00f1o: 8\n1 loops, best of 1: 186 ms per loop\n1 loops, best of 1: 24.4 ms per loop\nmatriz de tama\u00f1o: 9\n1 loops, best of 1: 272 ms per loop\n1 loops, best of 1: 155 ms per loop\nmatriz de tama\u00f1o: 10\n1 loops, best of 1: 400 ms per loop\n1 loops, best of 1: 494 ms per loop\nmatriz de tama\u00f1o: 11\n1 loops, best of 1: 551 ms per loop\n1 loops, best of 1: 2.09 s per loop\nmatriz de tama\u00f1o: 12\n1 loops, best of 1: 756 ms per loop\n1 loops, best of 1: 10.2 s per loop"}︡
︠548d454a-6a87-4980-b303-b38114d66d19i︠
%html
<p>Observamos que, en esta implementaci&oacute;n, para matrices hasta tama&ntilde;o 9-10 y entradas polinomios de grado 2 con coeficientes peque&ntilde;os es mejor usar el m&eacute;todo de Gauss, sin embargo, a partir de tama&ntilde;o 11, el coste del algoritmo de Gauss se vuelve prohibitivo, mientras que el m&eacute;todo de interpolaci&oacute;n todav&iacute;a es usable.</p>

<p>Vamos a hora a dibujar un gr&aacute;fico que represente el caso peor del tiempo de ejecuci&oacute;n en una matriz de polinomios. Compararemos</p>
<ul>
<li>El m&eacute;todo de Gauss</li>
<li>El m&eacute;todo del Teorema Chino de los restos</li>
<li>Los algoritmos internos considerada la matriz como matriz de polinomios</li>
<li>Los algoritmos internos considerada la matriz como matriz de funciones racionales</li>
</ul>

︡5e48b90c-33f1-4810-a60a-0a48e8f78421︡{"html": "<p>Observamos que, en esta implementaci&oacute;n, para matrices hasta tama&ntilde;o 9-10 y entradas polinomios de grado 2 con coeficientes peque&ntilde;os es mejor usar el m&eacute;todo de Gauss, sin embargo, a partir de tama&ntilde;o 11, el coste del algoritmo de Gauss se vuelve prohibitivo, mientras que el m&eacute;todo de interpolaci&oacute;n todav&iacute;a es usable.</p>\n\n<p>Vamos a hora a dibujar un gr&aacute;fico que represente el caso peor del tiempo de ejecuci&oacute;n en una matriz de polinomios. Compararemos</p>\n<ul>\n<li>El m&eacute;todo de Gauss</li>\n<li>El m&eacute;todo del Teorema Chino de los restos</li>\n<li>Los algoritmos internos considerada la matriz como matriz de polinomios</li>\n<li>Los algoritmos internos considerada la matriz como matriz de funciones racionales</li>\n</ul>"}︡
︠541afb9b-06ef-4248-afc9-21bf1f7970b6︠
from time import time
︡53deb48f-8840-450f-93d9-205ae4c7c800︡︡
︠7c6be566-784f-4c11-8b01-ebb90f80baf9︠
tiempo_Gauss1           = [0 for i in range(12)]
tiempo_chino1           = [0 for i in range(20)]
tiempo_sage_polinomio1  = [0 for i in range(20)]
tiempo_sage_racional1   = [0 for i in range(7)]

for j in range(3):
    for i in range(20):
        M = random_matrix(K, i)
        t = time()
        dummy = M.det()
        t = time() -t
        tiempo_sage_polinomio1[i] = max(t, tiempo_sage_polinomio1[i])
        M = M.change_ring(Kfield)
        if i < 12:
            t = time()
            dummy = determinante_a_la_Gauss(M)
            t = time() - t
            tiempo_Gauss1[i] = max(t, tiempo_Gauss1[i])
        if i < 7:
            t = time()
            dummy = M.det()
            t = time() - t
            tiempo_sage_racional1[i] = max(t, tiempo_sage_racional1[i])            
        t = time()
        dummy = determinante_chino(M)
        t = time() - t
        tiempo_chino1[i] = max(t, tiempo_chino1[i])
︡4ffc9c1a-2b0a-4550-825e-5c7f0d60f7b5︡︡
︠f031a500-16fc-4633-b027-7777e1526b6e︠
list_plot(tiempo_Gauss1, color='blue',plotjoined=True) + list_plot(tiempo_chino1, color='red', plotjoined=1) + list_plot(tiempo_sage_polinomio1, color='green', plotjoined=1) + list_plot(tiempo_sage_racional1, color='orange', plotjoined=1)
︡da71ff0b-dd10-439c-88ba-d0896ce539bf︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠fc67af4d-b02d-480a-ba64-a83cca365d66i︠
%html
<p style="text-align: center;"><span style="color: #0000ff;">En azul el tiempo que tarda el m&eacute;todo de Gauss</span></p>
<p style="text-align: center;"><span style="color: #ff0000;">En rojo el tiempo que tarda el m&eacute;todo de interpolaci&oacute;n</span></p>
<p style="text-align: center;"><span style="color: #ff0000;"><span style="color: #008000;">En verde, el tiempo que tarda el comando interno del determinante en Sage, como polinomios<br /></span></span></p>
<p style="text-align: center;"><span style="color: #ff0000;"><span style="color: #008000;"><span style="color: #ff6600;">En naranja, el tiempo que tarda el comando interno del determinante en Sage, como funciones racionales</span><br /></span></span></p>
<p>Como conlusi&oacute;n, no es sorprendente ver que el mejor m&eacute;todo es el determinante interno cuando las entradas son polinomios. Sin embargo, sorprende lo <strong>p&eacute;simo</strong> que es el m&eacute;todo por defecto sobre <strong>la misma matriz</strong> pero considerada en $\mathbb{Q}(x)$ en lugar de $\mathbb{Q}[x]$. Esto es debido a que no hay un m&eacute;todo espec&iacute;fico para $\mathbb{Q}(x)$ y est&aacute; usando un m&eacute;todo libre de divisiones que vale para cualquier cuerpo.</p>
<p>De los dos m&eacute;todos que hemos programado, para matries de mayor tama&ntilde;o es mucho mejor la interpolaci&oacute;n.</p>

<p>Veamos que ocurre con matrices con entradas funciones racionales.</p>

︡4571b37a-d7b4-4143-b41d-130261363ee1︡{"html": "<p style=\"text-align: center;\"><span style=\"color: #0000ff;\">En azul el tiempo que tarda el m&eacute;todo de Gauss</span></p>\n<p style=\"text-align: center;\"><span style=\"color: #ff0000;\">En rojo el tiempo que tarda el m&eacute;todo de interpolaci&oacute;n</span></p>\n<p style=\"text-align: center;\"><span style=\"color: #ff0000;\"><span style=\"color: #008000;\">En verde, el tiempo que tarda el comando interno del determinante en Sage, como polinomios<br /></span></span></p>\n<p style=\"text-align: center;\"><span style=\"color: #ff0000;\"><span style=\"color: #008000;\"><span style=\"color: #ff6600;\">En naranja, el tiempo que tarda el comando interno del determinante en Sage, como funciones racionales</span><br /></span></span></p>\n<p>Como conlusi&oacute;n, no es sorprendente ver que el mejor m&eacute;todo es el determinante interno cuando las entradas son polinomios. Sin embargo, sorprende lo <strong>p&eacute;simo</strong> que es el m&eacute;todo por defecto sobre <strong>la misma matriz</strong> pero considerada en $\\mathbb{Q}(x)$ en lugar de $\\mathbb{Q}[x]$. Esto es debido a que no hay un m&eacute;todo espec&iacute;fico para $\\mathbb{Q}(x)$ y est&aacute; usando un m&eacute;todo libre de divisiones que vale para cualquier cuerpo.</p>\n<p>De los dos m&eacute;todos que hemos programado, para matries de mayor tama&ntilde;o es mucho mejor la interpolaci&oacute;n.</p>\n\n<p>Veamos que ocurre con matrices con entradas funciones racionales.</p>"}︡
︠0170eaad-cbdc-4166-bc66-c583caf3ddd7︠
tiempo_Gauss = [0 for i in range(11)]
tiempo_chino = [0 for i in range(13)]
tiempo_sage  = [0 for i in range(7)]

for j in range(3):
    for i in range(13):
        M = random_matrix(Kfield, i)
        if i < 11:
            t = time()
            dummy = determinante_a_la_Gauss(M)
            t = time() - t
            tiempo_Gauss[i] = max(t, tiempo_Gauss[i])
        if i < 7:
            t = time()
            dummy = M.det()
            t = time() - t
            tiempo_sage[i] = max(t, tiempo_sage[i])            
        t = time()
        dummy = determinante_chino(M)
        t = time() - t
        tiempo_chino[i] = max(t, tiempo_chino[i])
︡6161c4ce-d8a1-4c86-8508-48e9ba755fe2︡︡
︠58528f3c-7f1c-4001-8ad4-1b1fd0de5e15︠
list_plot(tiempo_Gauss, color='blue',plotjoined=True) + list_plot(tiempo_chino, color='red', plotjoined=1) + list_plot(tiempo_sage, color='green', plotjoined=1)
︡eb0b13cd-c6d9-4274-92b2-63c5c0712499︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠7dba9884-d1d5-4d77-9fc8-720adb96002ci︠
%html
<p>Aqu&iacute; se puede apreciar que el m&eacute;todo interno para calcular determinantes en $\mathbb{Q}(x)$ debe ser modificado.</p>

︡c6f14f0a-d10a-4a09-a890-61159802a37a︡{"html": "<p>Aqu&iacute; se puede apreciar que el m&eacute;todo interno para calcular determinantes en $\\mathbb{Q}(x)$ debe ser modificado.</p>"}︡
